package com.jeeplus.modules.sg.project.service;

import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.project.entity.WbsItem;
import com.jeeplus.modules.sg.project.entity.WbsProject;
import com.jeeplus.modules.sg.project.entity.WbsSelection;
import com.jeeplus.modules.sg.project.mapper.ItemMapper;
import com.jeeplus.modules.sg.project.mapper.ProjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(readOnly = true)
public class ProjectService extends CrudService<ProjectMapper, WbsProject> {
    @Autowired
    private ProjectMapper projectMapper;
    @Autowired
    private ItemService itemService;


    public WbsProject get(String id) {
        return super.get(id);
    }


    public List<WbsProject> findList(WbsSelection wbsSelection) {
        List<WbsProject> list =  projectMapper.findList(wbsSelection);
        for(WbsProject wbsProject1 : list){
            String id = wbsProject1.getId();
            wbsSelection.setProjectId(id);
            List<WbsItem> items = itemService.findList(wbsSelection);
            wbsProject1.setWbsItems(items);
        }
        return list;
    }

    @Transactional(readOnly = false)
    public void save(WbsProject wbsProject) {
        super.save(wbsProject);
    }

    @Transactional(readOnly = false)
    public void delete(WbsProject wbsProject) {
        super.delete(wbsProject);
    }
}
